#include <stdio.h>
#include <time.h>
//#include <omp.h> 

int main(void)
{
	int i = 0;
	double pi = 0;
	const int iterationCount = 200000000;
	double start = 0, end = 0;

	pi = 0;
	start = clock();
	{
		for (i = 0 ; i < iterationCount ; i++)
		{
			pi +=  4* (i % 2 ? -1 : 1) / ( 2.0 * i + 1.0);
		}
	}
	end = clock();
	printf("(OpenMP ): %f, ɸð: %f\n", pi, (end - start)/1000);

	pi = 0;
	start = clock();

	#pragma omp parallel
	{
		#pragma omp for reduction(+:pi)
		for (i = 0 ; i < iterationCount ; i++)
		{
			pi +=  4* (i % 2 ? -1 : 1) / ( 2.0 * i + 1.0);
		}
	}
	end = clock();
	printf("(OpenMP ): %f, ɸð: %f\n", pi, (end - start)/1000);

	return 0;
}