#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int** alloc_dyn_array(int nRow, int nCol);
void input_array(int** ppResult, int nRow, int nCol);
void print_array(int** ppResult, int nRow, int nCol);
void free_dyn_array(int** ppResult, int nRow);

int get_max_value(int** ppResult, int nRow, int nCol);
int get_min_value(int** ppResult, int nRow, int nCol);

int main()
{
	int row = 0, col = 0;
	int max_value = 0, min_value = 0;
	int i = 0, j = 0;
	int	**ppResult = NULL;

	printf("(row) ũ? ");
	scanf("%d", &row);

	printf("(column) ũ? ");
	scanf("%d", &col);

	if (row <= 0 || col <= 0)
	{
		printf("  ũ 0 Ŀ մϴ\n");
		return 0;
	}

	ppResult = alloc_dyn_array(row, col);
	if (NULL != ppResult) 
	{
		input_array(ppResult, row, col);

		max_value = get_max_value(ppResult, row, col);

		min_value = get_min_value(ppResult, row, col);

		print_array(ppResult, row, col);

		printf("ִ : %d\n", max_value);

		printf("ּ : %d\n", min_value);

		free_dyn_array(ppResult, row);
	}

	return 0;
}

int get_max_value(int** ppResult, int nRow, int nCol)
{
	int result = 0;
	int i = 0, j = 0;
	if (NULL != ppResult && nRow > 0 && nCol > 0) 
	{
		result = ppResult[0][0];

		for(i = 0; i < nRow; i++) 
		{
			for(j = 0; j < nCol; j++) 
			{
				if (ppResult[i][j] > result)
				{
					result = ppResult[i][j];
				}
			}
		}
	}
	return result;
}

int get_min_value(int** ppResult, int nRow, int nCol)
{
	int result = 0;
	int i = 0, j = 0;
	if (NULL != ppResult && nRow > 0 && nCol > 0) 
	{
		result = ppResult[0][0];

		for(i = 0; i < nRow; i++) 
		{
			for(j = 0; j < nCol; j++) 
			{
				if (ppResult[i][j] < result)
				{
					result = ppResult[i][j];
				}
			}
		}
	}
	return result;
}

void input_array(int** ppResult, int nRow, int nCol)
{
	int i = 0, j = 0;
	if (NULL != ppResult && nRow > 0 && nCol > 0) 
	{
		for(i = 0; i < nRow; i++) 
		{
			for(j = 0; j < nCol; j++) 
			{
				printf("[%d][%d]? ", i, j);
				scanf("%d", &(ppResult[i][j]));
			}
		}
	}
}

void print_array(int** ppResult, int nRow, int nCol)
{
	int i = 0, j = 0;
	if (NULL != ppResult && nRow > 0 && nCol > 0) 
	{
		for(i = 0; i < nRow; i++) 
		{
			for(j = 0; j < nCol; j++) 
			{
				//printf("%d ", ppResult[i][j]);
				printf("%d ", *(*(ppResult + i) + j));
			}
			printf("\n");
		}
	}
}

int** alloc_dyn_array(int nRow, int nCol)
{
	int**	ppResult = NULL;
	int		i = 0;
	if (nRow > 0 && nCol > 0)
	{
		ppResult = (int**)malloc(sizeof(int*) * nRow);
		if (NULL != ppResult) 
		{
			for(i = 0; i < nRow; i++) 
			{
				ppResult[i] = (int *) malloc(sizeof(int) * nCol);
				if (NULL != ppResult[i]) 
				{
					memset(ppResult[i], 0, sizeof(int) * nCol);
				}
				else 
				{
					ppResult = NULL;
					break;
				}
			}
		}
	}
	else 
	{
		printf(": alloc_dyn_array() Է Ķ\n");
	}

	return ppResult;
}

void free_dyn_array(int** ppResult, int nRow)
{
	int i = 0, j = 0;
	if (NULL != ppResult && nRow > 0) 
	{
		for(i = 0; i < nRow; i++) 
		{
			if (NULL != ppResult[i]) 
			{
				free(ppResult[i]);
			}
		}

		free(ppResult);
	}
}
